



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Activity详解四  activity四种加载模式</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Activity详解四  activity四种加载模式</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 22:57:57 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>先看效果图:</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1028844/201609/1028844-20160920101626590-145509317.gif" /></p>
<h1>1概述</h1>
<p>Activity启动方式有四种，分别是：</p>
<p>standard</p>
<p>singleTop</p>
<p>singleTask</p>
<p>singleInstance</p>
<p>可以根据实际的需求为Activity设置对应的启动模式，从而可以避免创建大量重复的Activity等问题。</p>
<p>设置Activity的启动模式，只需要在AndroidManifest.xml里对应的&lt;activity&gt;标签设置android:launchMode属性，例如：</p>
<p>&lt;activity</p>
<p>android:name=".A1"</p>
<p>android:launchMode="standard"&nbsp;/&gt;</p>
<h1>2四种模式的作用</h1>
<h2>2.1 standard</h2>
<p>默认模式，可以不用写配置。在这个模式下，都会默认创建一个新的实例。因此，在这种模式下，可以有多个相同的实例，也允许多个相同Activity叠加。</p>
<p>例如：</p>
<p>若我有一个Activity名为A1, 上面有一个按钮可跳转到A1。那么如果我点击按钮，便会新启一个Activity A1叠在刚才的A1之上，再点击，又会再新启一个在它之上&hellip;&hellip;</p>
<p>点back键会依照栈顺序依次退出。</p>
<h2>2.2 singleTop</h2>
<p>可以有多个实例，但是不允许多个相同Activity叠加。即，如果Activity在栈顶的时候，启动相同的Activity，不会创建新的实例，而会调用其onNewIntent方法。</p>
<p>例如：</p>
<p>若我有两个Activity名为B1,B2,两个Activity内容功能完全相同，都有两个按钮可以跳到B1或者B2，唯一不同的是B1为standard，B2为singleTop。</p>
<p>若我意图打开的顺序为B1-&gt;B2-&gt;B2，则实际打开的顺序为B1-&gt;B2（后一次意图打开B2，实际只调用了前一个的onNewIntent方法）</p>
<p>若我意图打开的顺序为B1-&gt;B2-&gt;B1-&gt;B2，则实际打开的顺序与意图的一致，为B1-&gt;B2-&gt;B1-&gt;B2。</p>
<h2>2.3 singleTask</h2>
<p>只有一个实例。在同一个应用程序中启动他的时候，若Activity不存在，则会在当前task创建一个新的实例，若存在，则会把task中在其之上的其它Activity destory掉并调用它的onNewIntent方法。</p>
<p>如果是在别的应用程序中启动它，则会新建一个task，并在该task中启动这个Activity，singleTask允许别的Activity与其在一个task中共存，也就是说，如果我在这个singleTask的实例中再打开新的Activity，这个新的Activity还是会在singleTask的实例的task中。</p>
<p>例如：</p>
<p>若我的应用程序中有三个Activity,C1,C2,C3，三个Activity可互相启动，其中C2为singleTask模式，那么，无论我在这个程序中如何点击启动，如：C1-&gt;C2-&gt;C3-&gt;C2-&gt;C3-&gt;C1-C2，C1,C3可能存在多个实例，但是C2只会存在一个，并且这三个Activity都在同一个task里面。</p>
<p>但是C1-&gt;C2-&gt;C3-&gt;C2-&gt;C3-&gt;C1-C2，这样的操作过程实际应该是如下这样的，因为singleTask会把task中在其之上的其它Activity destory掉。</p>
<p>操作：C1-&gt;C2 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;C1-&gt;C2-&gt;C3&nbsp; &nbsp; &nbsp; &nbsp; &nbsp;&nbsp;C1-&gt;C2-&gt;C3-&gt;C2 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;C1-&gt;C2-&gt;C3-&gt;C2-&gt;C3-&gt;C1 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;&nbsp;C1-&gt;C2-&gt;C3-&gt;C2-&gt;C3-&gt;C1-C2</p>
<p>实际：C1-&gt;C2 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;C1-&gt;C2-&gt;C3 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;C1-&gt;C2 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;C1-&gt;C2-&gt;C3-&gt;C1 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; C1-&gt;C2</p>
<p>若是别的应用程序打开C2，则会新启一个task。</p>
<p>如别的应用Other中有一个activity，taskId为200，从它打开C2，则C2的taskIdI不会为200，例如C2的taskId为201，那么再从C2打开C1、C3，则C2、C3的taskId仍为201。</p>
<p>注意：如果此时你点击home，然后再打开Other，发现这时显示的肯定会是Other应用中的内容，而不会是我们应用中的C1 C2 C3中的其中一个。</p>
<h2>2.4 singleInstance</h2>
<p>只有一个实例，并且这个实例独立运行在一个task中，这个task只有这个实例，不允许有别的Activity存在。</p>
<p>例如：</p>
<p>程序有三个ActivityD1,D2,D3，三个Activity可互相启动，其中D2为singleInstance模式。那么程序从D1开始运行，假设D1的taskId为200，那么从D1启动D2时，D2会新启动一个task，即D2与D1不在一个task中运行。假设D2的taskId为201，再从D2启动D3时，D3的taskId为200，也就是说它被压到了D1启动的任务栈中。</p>
<p>若是在别的应用程序打开D2，假设Other的taskId为200，打开D2，D2会新建一个task运行，假设它的taskId为201，那么如果这时再从D2启动D1或者D3，则又会再创建一个task，因此，若操作步骤为other-&gt;D2-&gt;D1，这过程就涉及到了3个task了。</p>
<h1>3&nbsp;Demo源码</h1>
<p>activity</p>
<div>
<pre class="prettyprint linenums">package mm.shandong.com.testmodle;

import android.content.Intent;<br />
import android.support.v7.app.AppCompatActivity;<br />
import android.os.Bundle;<br />
import android.view.View;

public class TestModleActivity extends AppCompatActivity {

    @Override<br />
    protected void onCreate(Bundle savedInstanceState) {<br />
        super.onCreate(savedInstanceState);<br />
        setContentView(R.layout.activity_test_modle);<br />
    }<br />
    ///启动标准启动模式的activity<br />
    public void testStandard(View view){<br />
        Intent intent=new Intent(this,TestModleActivity1.class);<br />
        startActivity(intent);<br />
    }<br />
    ///启动SingleTop启动模式的activity<br />
    public void testSingleTop(View view){<br />
        Intent intent=new Intent(this,TestModleActivity2.class);<br />
        startActivity(intent);<br />
    }<br />
    ///启动SingleTask启动模式的activity<br />
    public void testSingleTask(View view){<br />
        Intent intent=new Intent(this,TestModleActivity3.class);<br />
        startActivity(intent);<br />
    }<br />
    ///启动SingleInstance启动模式的activity<br />
    public void testSingleInstance(View view){

        Intent intent = new Intent(Intent.ACTION_DIAL);

        startActivity(intent);<br />
    }<br />
}
</pre>
</div>
<p>清单文件：</p>
<div>
<pre class="prettyprint linenums">&lt;?xml version="1.0" encoding="utf-8"?&gt;<br />
&lt;manifest xmlns:android="http://schemas.android.com/apk/res/android"<br />
    package="mm.shandong.com.testmodle" &gt;

    &lt;application<br />
        android:allowBackup="true"<br />
        android:icon="@mipmap/ic_launcher"<br />
        android:label="@string/app_name"<br />
        android:supportsRtl="true"<br />
        android:theme="@style/AppTheme" &gt;<br />
        &lt;activity android:name=".TestModleActivity" &gt;<br />
            &lt;intent-filter&gt;<br />
                &lt;action android:name="android.intent.action.MAIN" /&gt;

                &lt;category android:name="android.intent.category.LAUNCHER" /&gt;<br />
            &lt;/intent-filter&gt;<br />
        &lt;/activity&gt;<br />
        &lt;activity<br />
            android:name=".TestModleActivity2"<br />
            android:configChanges="keyboardHidden|orientation|screenSize"<br />
            android:launchMode="singleTop" /&gt;<br />
        &lt;activity<br />
            android:name=".TestModleActivity1"<br />
            android:configChanges="keyboardHidden|orientation|screenSize" /&gt;<br />
        &lt;activity<br />
            android:name=".TestModleActivity3"<br />
            android:configChanges="keyboardHidden|orientation|screenSize" /&gt;<br />
        &lt;activity<br />
            android:name=".TestModleActivity4"<br />
            android:configChanges="keyboardHidden|orientation|screenSize" /&gt;<br />
        &lt;activity<br />
            android:name=".TestModleActivity5"<br />
            android:configChanges="keyboardHidden|orientation|screenSize" /&gt;<br />
    &lt;/application&gt;

&lt;/manifest&gt;
</pre>
</div>
<p>本人微博：<a href="http://weibo.com/u/2453028507?refer_flag=1001030102_&amp;is_hot=1" rel="external nofollow noreferrer">honey_11</a></p>
<p>Demo下载<br />最后，以上例子都来源与安卓无忧，请去应用宝或者豌豆荚下载：<a href="http://android.myapp.com/myapp/detail.htm?apkName=com.shandong.mm.androidstudy" rel="external nofollow noreferrer">例子源码</a>，源码例子文档一网打尽</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8kj1739.html">WPF TextBox 搜索框 自定义</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqln5o18.html">Java语言程序设计&lpar;基础篇&rpar; 第七章 一维数组</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxo04eq.html">Boost学习笔记（五） progress&lowbar;display</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql417e9.html">JAVA学习AWT绘图</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qx1ywd9.html">38&period;输出1到最大的N位数&lbrack;Print 1 to max number of N bits&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yge15q.html">Response&period;Cookies 和 Request&period;Cookies</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmrz2e9.html">阿里云主机安装Memcached</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mngkz0q.html">js查找元素</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj1gzj8.html">PHP JSON&lowbar;ENCODE 不转义中文汉字的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge03xl8.html">Yii2中JSONP跨域问题的解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jg7ojq.html">2 Class类</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllnp71q.html">es6之箭头函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnv57dg8.html">c&num;代码文件上传和下载</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwk3jv9.html">python&lowbar;高级特征</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjrj1z9.html">MySql：SELECT 语句（二）排序 ORDER BY 的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/90r1n039.html">工作中常用到的Vim命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjdwzj9.html">WIN10安装时msxml4&period;0提示2502、2503解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25plwwq.html">JAVA面试精选【Java web部分一】</a>
		</li>
						<li><a href="https://www.batexi.com/a/8em5ove9.html">Linux基础命令---eject</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyv0ywgq.html">Hadoop&lpar;1&rpar;-CentOS6&period;8的安装&comma;配置和克隆</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/1q25yrvq.html">MVC5 网站开发实践  2&period;1、管理员登陆</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1r2x08.html">&num; Hawk：开源贡献计划，设计，反思</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9j16rw9.html">Microsoft Message Analyzer （微软消息分析器，&amp;ldquo&semi;网络抓包工具 - Network Monitor&amp;rdquo&semi;的替代品）官方正式版现已发布</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93w2yzq.html">BOM详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qnvzr28.html">js构建ui的统一异常处理方案（三）</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdwy609.html">分享我基于NPOI&plus;ExcelReport实现的导入与导出EXCEL类库：ExcelUtility （续2篇-模板导出综合示例）</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqv24do9.html">LINQ to SQL语句&lpar;12&rpar;之Delete和使用Attach</a>
			</li>
						<li><a href="https://www.batexi.com/a/495g2ovq.html">hostingEnvironment与宿主环境</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4jlxjq.html">常见的Web实时消息交互方式和SignalR</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8m23xrq.html">NIOS II 中直接调用Modelsim仿真</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
